diff --git a/include/SeasLog.h b/include/SeasLog.h
index 6e19717..c63914d 100644
--- a/include/SeasLog.h
+++ b/include/SeasLog.h
@@ -37,96 +37,102 @@
 
 #include <stdlib.h>
 
-#define SEASLOG_RES_NAME                    "SeasLog"
-#define SEASLOG_AUTHOR                      "Chitao.Gao  [ neeke@php.net ]"
-#define SEASLOG_VERSION                     "1.8.5"
-#define SEASLOG_VERSION_ID                  10805
-#define SEASLOG_SUPPORTS                    "https://github.com/SeasX/SeasLog"
+#define SEASLOG_RES_NAME                        "SeasLog"
+#define SEASLOG_AUTHOR                          "Chitao.Gao  [ neeke@php.net ]"
+#define SEASLOG_VERSION                         "1.8.6"
+#define SEASLOG_VERSION_ID                      10806
+#define SEASLOG_SUPPORTS                        "https://github.com/SeasX/SeasLog"
 
-#define SEASLOG_ALL                         "ALL"
-#define SEASLOG_DEBUG                       "DEBUG"
-#define SEASLOG_INFO                        "INFO"
-#define SEASLOG_NOTICE                      "NOTICE"
-#define SEASLOG_WARNING                     "WARNING"
-#define SEASLOG_ERROR                       "ERROR"
-#define SEASLOG_CRITICAL                    "CRITICAL"
-#define SEASLOG_ALERT                       "ALERT"
-#define SEASLOG_EMERGENCY                   "EMERGENCY"
+#define SEASLOG_ALL                             "ALL"
+#define SEASLOG_DEBUG                           "DEBUG"
+#define SEASLOG_INFO                            "INFO"
+#define SEASLOG_NOTICE                          "NOTICE"
+#define SEASLOG_WARNING                         "WARNING"
+#define SEASLOG_ERROR                           "ERROR"
+#define SEASLOG_CRITICAL                        "CRITICAL"
+#define SEASLOG_ALERT                           "ALERT"
+#define SEASLOG_EMERGENCY                       "EMERGENCY"
 
-#define SEASLOG_ALL_INT                     8
-#define SEASLOG_DEBUG_INT                   7
-#define SEASLOG_INFO_INT                    6
-#define SEASLOG_NOTICE_INT                  5
-#define SEASLOG_WARNING_INT                 4
-#define SEASLOG_ERROR_INT                   3
-#define SEASLOG_CRITICAL_INT                2
-#define SEASLOG_ALERT_INT                   1
-#define SEASLOG_EMERGENCY_INT               0
+#define SEASLOG_ALL_INT                         8
+#define SEASLOG_DEBUG_INT                       7
+#define SEASLOG_INFO_INT                        6
+#define SEASLOG_NOTICE_INT                      5
+#define SEASLOG_WARNING_INT                     4
+#define SEASLOG_ERROR_INT                       3
+#define SEASLOG_CRITICAL_INT                    2
+#define SEASLOG_ALERT_INT                       1
+#define SEASLOG_EMERGENCY_INT                   0
 
-#define SEASLOG_SYSLOG_FACILITY             8 //LOG_USER
+#define SEASLOG_SYSLOG_FACILITY                 8 //LOG_USER
 
-#define SEASLOG_APPENDER_FILE               1
-#define SEASLOG_APPENDER_TCP                2
-#define SEASLOG_APPENDER_UDP                3
+#define SEASLOG_APPENDER_FILE                   1
+#define SEASLOG_APPENDER_TCP                    2
+#define SEASLOG_APPENDER_UDP                    3
 
-#define SEASLOG_DETAIL_ORDER_ASC            1
-#define SEASLOG_DETAIL_ORDER_DESC           2
+#define SEASLOG_DETAIL_ORDER_ASC                1
+#define SEASLOG_DETAIL_ORDER_DESC               2
 
-#define SEASLOG_EVENT_ERROR                 1
-#define SEASLOG_EVENT_EXCEPTION             2
+#define SEASLOG_EVENT_ERROR                     1
+#define SEASLOG_EVENT_EXCEPTION                 2
 
-#define SEASLOG_DIR_MODE                    (mode_t)0777
-#define SEASLOG_FILE_MODE                   (mode_t)0666
+#define SEASLOG_DIR_MODE                        (mode_t)0777
+#define SEASLOG_FILE_MODE                       (mode_t)0666
 
-#define SEASLOG_INIT_FIRST_YES              1
-#define SEASLOG_INIT_FIRST_NO               2
+#define SEASLOG_INIT_FIRST_YES                  1
+#define SEASLOG_INIT_FIRST_NO                   2
 
-#define SEASLOG_BUFFER_RE_INIT_YES          1
-#define SEASLOG_BUFFER_RE_INIT_NO           2
+#define SEASLOG_BUFFER_RE_INIT_YES              1
+#define SEASLOG_BUFFER_RE_INIT_NO               2
 
-#define SEASLOG_INITR_COMPLETE_YES          1
-#define SEASLOG_INITR_COMPLETE_NO           2
+#define SEASLOG_INITR_COMPLETE_YES              1
+#define SEASLOG_INITR_COMPLETE_NO               2
 
-#define SEASLOG_PROCESS_LOGGER_LAST         1
-#define SEASLOG_PROCESS_LOGGER_TMP          2
+#define SEASLOG_PROCESS_LOGGER_LAST             1
+#define SEASLOG_PROCESS_LOGGER_TMP              2
 
-#define SL_S(s)                             s, sizeof(s) - 1
+#define SL_S(s)                                 s, sizeof(s) - 1
 
-#define SEASLOG_HASH_VALUE_LOGGER           1
-#define SEASLOG_HASH_VALUE_PATH             2
-#define SEASLOG_HASH_VALUE_ACCESS           3
+#define SEASLOG_HASH_VALUE_LOGGER               1
+#define SEASLOG_HASH_VALUE_PATH                 2
+#define SEASLOG_HASH_VALUE_ACCESS               3
 
-#define SEASLOG_BUFFER_MAX_SIZE             65535
+#define SEASLOG_BUFFER_MAX_SIZE                 65535
 
-#define SEASLOG_TRIM_WRAP                   26
+#define SEASLOG_TRIM_WRAP                       26
 
-#define SEASLOG_EXCEPTION_LOGGER_ERROR      4403
-#define SEASLOG_EXCEPTION_CONTENT_ERROR     4406
-#define SEASLOG_EXCEPTION_WINDOWS_ERROR     4407
+#define SEASLOG_EXCEPTION_LOGGER_ERROR          4403
+#define SEASLOG_EXCEPTION_CONTENT_ERROR         4406
+#define SEASLOG_EXCEPTION_WINDOWS_ERROR         4407
 
-#define SEASLOG_GET_HOST_NULL               "NoHost"
+#define SEASLOG_GET_HOST_NULL                   "NoHost"
 
-#define SEASLOG_CLI_KEY                     "cli"
-#define SEASLOG_PHPDBG_KEY                  "phpdbg"
+#define SEASLOG_CLI_KEY                         "cli"
+#define SEASLOG_PHPDBG_KEY                      "phpdbg"
 
-#define SEASLOG_LOGGER_SLASH                "/"
-#define SEASLOG_LOGGER_UNDERLINE            "_"
-#define SEASLOG_ASTERISK                    "*"
+#define SEASLOG_LOGGER_SLASH                    "/"
+#define SEASLOG_LOGGER_UNDERLINE                "_"
+#define SEASLOG_ASTERISK                        "*"
 
-#define SEASLOG_LOG_LINE_FEED_STR           "\n"
-#define SEASLOG_LOG_LINE_FEED_LEN           sizeof(SEASLOG_LOG_LINE_FEED_STR) - 1
+#define SEASLOG_LOG_LINE_FEED_STR               "\n"
+#define SEASLOG_LOG_LINE_FEED_LEN               sizeof(SEASLOG_LOG_LINE_FEED_STR) - 1
 
-#define SEASLOG_GENERATE_CURRENT_TEMPLATE   1
-#define SEASLOG_GENERATE_LOG_INFO           2
-#define SEASLOG_GENERATE_SYSLOG_INFO        3
+#define SEASLOG_GENERATE_CURRENT_TEMPLATE       1
+#define SEASLOG_GENERATE_LOG_INFO               2
+#define SEASLOG_GENERATE_SYSLOG_INFO            3
 
-#define SEASLOG_ANALYZER_DEFAULT_START      1
-#define SEASLOG_ANALYZER_DEFAULT_OFFSET     20
+#define SEASLOG_ANALYZER_DEFAULT_START          1
+#define SEASLOG_ANALYZER_DEFAULT_OFFSET         20
 
-#define SEASLOG_GLOBAL_VARS_SERVER  		TRACK_VARS_SERVER
+#define SEASLOG_STREAM_LIST_DESTROY_YES         1
+#define SEASLOG_STREAM_LIST_DESTROY_NO          2
+
+#define SEASLOG_CLOSE_LOGGER_STREAM_MOD_ALL     1
+#define SEASLOG_CLOSE_LOGGER_STREAM_MOD_ASSIGN  2
+
+#define SEASLOG_GLOBAL_VARS_SERVER  		    TRACK_VARS_SERVER
 
 #ifndef PHP_STREAM_URL_STAT_NOCACHE
-#define PHP_STREAM_URL_STAT_NOCACHE	        4
+#define PHP_STREAM_URL_STAT_NOCACHE	            4
 #endif
 
 #if PHP_VERSION_ID >= 70000
diff --git a/include/StreamWrapper.h b/include/StreamWrapper.h
index d4ac48b..450778e 100644
--- a/include/StreamWrapper.h
+++ b/include/StreamWrapper.h
@@ -20,7 +20,7 @@
 #include "php_seaslog.h"
 
 void seaslog_init_stream_list(TSRMLS_D);
-void seaslog_clear_stream_list(TSRMLS_D);
+void seaslog_clear_stream_list(int destroy TSRMLS_DC);
 php_stream *process_stream(char *opt, int opt_len TSRMLS_DC);
 
 #endif /* _SEASLOG_STREAMWRAPPER_H_ */
diff --git a/php_seaslog.h b/php_seaslog.h
index 3d9c5ea..7d58862 100755
--- a/php_seaslog.h
+++ b/php_seaslog.h
@@ -148,6 +148,7 @@ PHP_METHOD(SEASLOG_RES_NAME, getBasePath);
 PHP_METHOD(SEASLOG_RES_NAME, setRequestID);
 PHP_METHOD(SEASLOG_RES_NAME, getRequestID);
 PHP_METHOD(SEASLOG_RES_NAME, setLogger);
+PHP_METHOD(SEASLOG_RES_NAME, closeLoggerStream);
 PHP_METHOD(SEASLOG_RES_NAME, getLastLogger);
 PHP_METHOD(SEASLOG_RES_NAME, setDatetimeFormat);
 PHP_METHOD(SEASLOG_RES_NAME, getDatetimeFormat);
diff --git a/seaslog.c b/seaslog.c
index 325106f..bbcef17 100644
--- a/seaslog.c
+++ b/seaslog.c
@@ -68,6 +68,11 @@ ZEND_BEGIN_ARG_INFO_EX(seaslog_setLogger_arginfo, 0, 0, 1)
 ZEND_ARG_INFO(0, logger)
 ZEND_END_ARG_INFO()
 
+ZEND_BEGIN_ARG_INFO_EX(seaslog_closeLoggerStream_arginfo, 0, 0, 1)
+ZEND_ARG_INFO(0, model)
+ZEND_ARG_INFO(0, logger)
+ZEND_END_ARG_INFO()
+
 ZEND_BEGIN_ARG_INFO_EX(seaslog_setDatetimeFormat_arginfo, 0, 0, 1)
 ZEND_ARG_INFO(0, format)
 ZEND_END_ARG_INFO()
@@ -108,6 +113,7 @@ const zend_function_entry seaslog_methods[] =
     PHP_ME(SEASLOG_RES_NAME, setBasePath,   seaslog_setBasePath_arginfo, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
     PHP_ME(SEASLOG_RES_NAME, getBasePath,   NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
     PHP_ME(SEASLOG_RES_NAME, setLogger,     seaslog_setLogger_arginfo, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
+    PHP_ME(SEASLOG_RES_NAME, closeLoggerStream,     seaslog_closeLoggerStream_arginfo, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
     PHP_ME(SEASLOG_RES_NAME, getLastLogger, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
 
     PHP_ME(SEASLOG_RES_NAME, setRequestID,  seaslog_setRequestID_arginfo, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
@@ -213,6 +219,9 @@ PHP_MINIT_FUNCTION(seaslog)
     REGISTER_LONG_CONSTANT("SEASLOG_APPENDER_TCP", SEASLOG_APPENDER_TCP, CONST_PERSISTENT | CONST_CS);
     REGISTER_LONG_CONSTANT("SEASLOG_APPENDER_UDP", SEASLOG_APPENDER_UDP, CONST_PERSISTENT | CONST_CS);
 
+    REGISTER_LONG_CONSTANT("SEASLOG_CLOSE_LOGGER_STREAM_MOD_ALL", SEASLOG_CLOSE_LOGGER_STREAM_MOD_ALL, CONST_PERSISTENT | CONST_CS);
+    REGISTER_LONG_CONSTANT("SEASLOG_CLOSE_LOGGER_STREAM_MOD_ASSIGN", SEASLOG_CLOSE_LOGGER_STREAM_MOD_ASSIGN, CONST_PERSISTENT | CONST_CS);
+
     INIT_CLASS_ENTRY(seaslog, SEASLOG_RES_NAME, seaslog_methods);
 
 #if PHP_VERSION_ID >= 70000
@@ -274,7 +283,7 @@ PHP_RSHUTDOWN_FUNCTION(seaslog)
     seaslog_clear_host_name(TSRMLS_C);
     seaslog_clear_template(TSRMLS_C);
     seaslog_clear_request_variable(TSRMLS_C);
-    seaslog_clear_stream_list(TSRMLS_C);
+    seaslog_clear_stream_list(SEASLOG_STREAM_LIST_DESTROY_YES TSRMLS_CC);
     return SUCCESS;
 }
 
@@ -459,7 +468,7 @@ PHP_METHOD(SEASLOG_RES_NAME, getBasePath)
 }
 /* }}} */
 
-/* {{{ proto bool setBasePath(string logger)
+/* {{{ proto bool setLogger(string logger)
    Set SeasLog logger path */
 PHP_METHOD(SEASLOG_RES_NAME, setLogger)
 {
@@ -485,6 +494,52 @@ PHP_METHOD(SEASLOG_RES_NAME, setLogger)
 }
 /* }}} */
 
+/* {{{ proto bool closeLoggerStream([int model, string logger])
+   Close SeasLog logger stream */
+PHP_METHOD(SEASLOG_RES_NAME, closeLoggerStream)
+{
+    zval *_module;
+    long model = 1;
+    int argc = ZEND_NUM_ARGS();
+
+    if (zend_parse_parameters(argc TSRMLS_CC, "|lz", &model, &_module) == FAILURE)
+    {
+        return;
+    }
+
+    if (argc == 0)
+    {
+        model = SEASLOG_CLOSE_LOGGER_STREAM_MOD_ALL;
+    }
+
+    if (model == SEASLOG_CLOSE_LOGGER_STREAM_MOD_ALL)
+    {
+        seaslog_shutdown_buffer(SEASLOG_BUFFER_RE_INIT_YES TSRMLS_CC);
+        seaslog_clear_stream_list(SEASLOG_STREAM_LIST_DESTROY_NO TSRMLS_CC);
+        RETURN_TRUE;
+    }
+
+    if (argc > 0 && model == SEASLOG_CLOSE_LOGGER_STREAM_MOD_ASSIGN && argc < 2)
+    {
+        php_error_docref(NULL TSRMLS_CC, E_WARNING, "With the first argument is SEASLOG_CLOSE_LOGGER_STREAM_MOD_ASSIGN, the second argument is required.");
+        RETURN_FALSE;
+    }
+
+//
+//    if (argc > 0 && (IS_STRING == Z_TYPE_P(_module) && Z_STRLEN_P(_module) > 0))
+//    {
+//        if (strncmp(SEASLOG_G(last_logger)->logger,Z_STRVAL_P(_module),Z_STRLEN_P(_module)))
+//        {
+//            process_logger(Z_STRVAL_P(_module), Z_STRLEN_P(_module), SEASLOG_PROCESS_LOGGER_LAST TSRMLS_CC);
+//        }
+//
+//        RETURN_TRUE;
+//    }
+
+    RETURN_FALSE;
+}
+/* }}} */
+
 /* {{{ proto string getLastLogger()
    Get SeasLog last logger path */
 PHP_METHOD(SEASLOG_RES_NAME, getLastLogger)
diff --git a/src/StreamWrapper.c b/src/StreamWrapper.c
index 8c60bba..77b3608 100644
--- a/src/StreamWrapper.c
+++ b/src/StreamWrapper.c
@@ -101,7 +101,7 @@ void seaslog_init_stream_list(TSRMLS_D)
 
 }
 
-void seaslog_clear_stream_list(TSRMLS_D)
+void seaslog_clear_stream_list(int destroy TSRMLS_DC)
 {
     php_stream *stream = NULL;
     HashTable *ht;
@@ -111,6 +111,7 @@ void seaslog_clear_stream_list(TSRMLS_D)
     zend_string *str_key;
     zval *stream_zval_get_php7;
 #else
+    ulong num_key;
     zval **stream_zval_get;
 #endif
 
@@ -124,11 +125,15 @@ void seaslog_clear_stream_list(TSRMLS_D)
             if (stream)
             {
                 php_stream_close(stream);
+                zend_hash_index_del(ht, num_key);
             }
         }
         ZEND_HASH_FOREACH_END();
 
-        EX_ARRAY_DESTROY(&SEASLOG_G(stream_list));
+        if (SEASLOG_STREAM_LIST_DESTROY_YES == destroy)
+        {
+            EX_ARRAY_DESTROY(&SEASLOG_G(stream_list));
+        }
     }
 #else
     if (SEASLOG_G(stream_list) && IS_ARRAY == Z_TYPE_P(SEASLOG_G(stream_list)))
@@ -138,15 +143,20 @@ void seaslog_clear_stream_list(TSRMLS_D)
         zend_hash_internal_pointer_reset(ht);
         while (zend_hash_get_current_data(ht, (void **)&stream_zval_get) == SUCCESS)
         {
+            zend_hash_get_current_key_ex(ht, NULL, NULL, &num_key, 1, NULL);
             php_stream_from_zval_no_verify(stream,stream_zval_get);
             if (stream)
             {
                 php_stream_close(stream);
+                zend_hash_index_del(ht, num_key);
             }
             zend_hash_move_forward(ht);
         }
 
-        EX_ARRAY_DESTROY(&(SEASLOG_G(stream_list)));
+        if (SEASLOG_STREAM_LIST_DESTROY_YES == destroy)
+        {
+            EX_ARRAY_DESTROY(&(SEASLOG_G(stream_list)));
+        }
     }
 #endif
 
diff --git a/tests/015.phpt b/tests/015.phpt
new file mode 100644
index 0000000..8f817ab
--- /dev/null
+++ b/tests/015.phpt
@@ -0,0 +1,31 @@
+--TEST--
+Check for SeasLog::closeLoggerStream() function.
+--SKIPIF--
+<?php
+if (!extension_loaded('seaslog')
+    || !method_exists('SeasLog','closeLoggerStream'))
+{
+    print 'skip';
+}
+?>
+--FILE--
+<?php
+var_dump(SeasLog::setLogger('logger'));
+var_dump(SeasLog::debug('this is a debug log {test}.',array('test' => 'replace')));
+var_dump(SeasLog::info('this is a info log {test}.',array('test' => 'replace')));
+var_dump(SeasLog::notice('this is a notice log {test}.',array('test' => 'replace')));
+var_dump(SeasLog::warning('this is a warning log {test}.',array('test' => 'replace')));
+var_dump(SeasLog::closeLoggerStream());
+var_dump(SeasLog::closeLoggerStream(SEASLOG_CLOSE_LOGGER_STREAM_MOD_ALL));
+var_dump(SeasLog::warning('this is a warning log {test}.',array('test' => 'replace')));
+?>
+--EXPECT--
+bool(true)
+bool(true)
+bool(true)
+bool(true)
+bool(true)
+bool(true)
+bool(true)
+bool(true)
+
